//
//  EnxCallManager.swift
//  Enx_CallKit_iOS
//
//  Created by jaykumar on 26/05/22.
//

import UIKit
import CallKit
class EnxCallManager: NSObject {
    let callCont = CXCallController()
    var enxManager = EnxGlobalManager.enxGlobalManager
    //Update for start call
    func startCall(handle : String, Video:Bool){
        let handle = CXHandle(type: .phoneNumber, value: handle)
        let startCall = CXStartCallAction(call: enxManager.getUUID(), handle: handle)
        startCall.isVideo = enxManager.getHasVideo()
        let callTransaction = CXTransaction()
        callTransaction.addAction(startCall)
        requestCall(callTrans: callTransaction, action: "StartCall")
    }
    //Update for End call
    func endCall(call : EnxCalls){
        let endCall = CXEndCallAction(call: call.uuid)
        let callTransaction = CXTransaction()
        callTransaction.addAction(endCall)
        requestCall(callTrans: callTransaction, action: "endCall")
    }
    //Update for Hold call
    func setHeld(call : EnxCalls , onHold : Bool){
        let handleCall = CXSetHeldCallAction(call: call.uuid, onHold: onHold)
        let callTransaction = CXTransaction()
        callTransaction.addAction(handleCall)
        requestCall(callTrans: callTransaction, action: "holdCall")
    }
    //Common Method
    private func requestCall(callTrans: CXTransaction , action : String){
        callCont.request(callTrans, completion: { error in
            if let error = error{
                print("Error requesting transaction: \(error)")
            }
            else{
               print("Requested transaction \(action) successfully")
            }
        })
    }
    //Mark : Call Managment
    static let callsChangedNotification = Notification.Name("CallsChangedNotification")
    private(set) var calls = [EnxCalls]()
    func callWithUUID(uuid : UUID) -> EnxCalls?{
        if calls.count > 0{
            return calls[0]
        }
        return nil
    }
    //Add call in list when started
    func addCall(_ call : EnxCalls){
        calls.append(call)
        call.stateDidChange = {[weak self] in
            self?.postCallNotification()
        }
        postCallNotification()
    }
    //Remove a specifice call from List
    func removeCall(_ Call : EnxCalls){
        let index = calls.firstIndex(where: {
            $0 === Call
        })
        calls.remove(at: index!)
        postCallNotification()
    }
    //Remove all calls  from List
    func removeAllCalls(){
        if(calls.count > 0){
            calls.removeAll()
        }
        postCallNotification()
    }
    //Update Notification
    private func postCallNotification(){
        //NotificationCenter.default.post(name: type(of: self).callsChangedNotification, object: self)
    }

}
